// Application : ddFramework
// jhnApplicationDriver.prg , Created : 2014/12/08   04:25 AM
// User : Johan

#using jhnFT.Utils.Config
#using System.Windows.Forms
#using System.Collections.Generic

BEGIN NAMESPACE jhnFT.Utils.Config

	SEALED CLASS jhnApplicationDriver
		STATIC HIDDEN _inst AS jhnApplicationDriver

		STATIC CONSTRUCTOR()
			_inst := jhnApplicationDriver{}
		RETURN

		HIDDEN CONSTRUCTOR()
			SUPER()
			SELF:InitializeAppDriver()
		RETURN

		STATIC PROPERTY Inst AS jhnApplicationDriver
			GET
				RETURN _inst
			END GET
		END PROPERTY

		HIDDEN METHOD InitializeAppDriver() AS VOID
//			SELF:Exec() //Uncomment this line if you want to see if only 1 instance of Exec[(<iApp>)] is achieved.
		RETURN

		INTERNAL METHOD Exec() AS VOID
			STATIC LOCAL iCount := 0 AS INT
			IF iCount++ = 0
				BEGIN SCOPE
					LOCAL appidx AS INT[]
					LOCAL ddSD AS jhnSetupDict
					appidx := (ddSD := jhnSetupDict.Inst):LkpItemGet("application")
					IF appidx:Length = 1
						jhnMemberInterface.Inst:MemberAdd(ddSD:ClassPropertyGet(appidx[0]))
					ELSEIF appidx:Length > 1
						jhnMemberInterface.Inst:MemberAdd(ddSD:ClassPropertyGet(ddSD:LkpItemGet("applist")[0]))
					ELSE
						MessageBox.Show("No application defined!", SELF:GetType():ToString() + ":Exec()", ;
												MessageBoxButtons.OK, MessageBoxIcon.Stop)
					ENDIF
				END SCOPE
			ELSE
				MessageBox.Show("Only one instance of the application driver is allowed per active session!", ;
										SELF:GetType():ToString(), ;
										MessageBoxButtons.OK, MessageBoxIcon.Stop)
			ENDIF
		RETURN
 
	END CLASS

END NAMESPACE

