// Application : jhnCollections
// jhnTokenFun.prg , Created : 2008-12-15   03:22 PM

CLASS jhnTokenString
	PROTECT sStr, sDel AS STRING
	PROTECT sSplit AS STRING[]

	CONSTRUCTOR()
		SELF:InitToken("", ";")
	RETURN
	CONSTRUCTOR(s AS STRING)
		SELF:InitToken(s, ";")
	RETURN
	CONSTRUCTOR(s AS STRING, d AS STRING)
		SELF:InitToken(s, d)
	RETURN
	METHOD InitToken(s AS STRING, d AS STRING) AS VOID
		SELF:sStr := s
		SELF:sDel := d
		SELF:sSplit := SELF:sStr:Split(SELF:sDel:ToCharArray())
	RETURN
	ACCESS Value AS STRING
	RETURN SELF:sStr
	PROPERTY Count AS INT
		GET
			RETURN SELF:sSplit:Length
		END GET
	END PROPERTY
		
	METHOD Get(nNum AS INT) AS STRING
		LOCAL sToken AS STRING
		IF nNum < SELF:sSplit:Length
			sToken := SELF:sSplit[nNum]
		ELSE
			sToken := ""
		ENDIF
//		MessageBox.Show(sToken, nNum:ToString())
	RETURN sToken

	METHOD SubToken(sName AS STRING, sD AS STRING) AS STRING
	RETURN SELF:SubToken(sName, sD, 1)
	METHOD SubToken(sName AS STRING, sD AS STRING, nPos AS INT) AS STRING
		LOCAL sSub AS jhnTokenString
		LOCAL sSplit AS STRING[]
		LOCAL sRet AS STRING
		LOCAL nCnt AS INT
		FOR nCnt := 0 UPTO sSplit:Length - 1
			sSub := jhnTokenString{sSplit[nCnt], sD}
			IF sSub:Get(nPos):ToUpper() = sName:ToUpper()
				sRet := sSplit[nCnt]
				EXIT
			ENDIF
		NEXT
//		MessageBox.Show(sName + sD + sRet, procname())
	RETURN sRet

END CLASS
